
/*
 *	This file was automatically generated by dbusxx-xml2cpp; DO NOT EDIT!
 */

#ifndef DBUSXXX____INCLUDE_DBUS_C___DBUS_PROXY_PROXY_MARSHAL_H
#define DBUSXXX____INCLUDE_DBUS_C___DBUS_PROXY_PROXY_MARSHAL_H

#include <dbus-c++/dbus.h>
#include <memory>

namespace org {
namespace freedesktop {

class DBus_proxy
 : virtual public ::DBus::CallbackTarget, public ::DBus::InterfaceProxy
{
public:

	DBus_proxy()
   : ::DBus::CallbackTarget()
	, ::DBus::InterfaceProxy("org.freedesktop.DBus") {
		connect_signal(DBus_proxy, NameOwnerChanged, _NameOwnerChanged_stub);
		connect_signal(DBus_proxy, NameLost, _NameLost_stub);
		connect_signal(DBus_proxy, NameAcquired, _NameAcquired_stub);
	}

	// Context of the response to a received pending call
	class CallContext : public ::DBus::CallInfo
	{
	public:

		DBus_proxy &iface;
		void *data;

		CallContext(DBus_proxy &ifc, ::DBus::PendingCall &call, void *ptr)
		: ::DBus::CallInfo(ifc.object().conn(), call), iface(ifc), data(ptr) {}

	private:

		// Not implemented to prevent copy-construction
		CallContext(const CallContext &);
	};

private:

	// Class member function binding for "RequestName"
	template < class Delegate >
	struct _RequestName_memBind {
		typedef void (Delegate::*Method)(
			const uint32_t &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_RequestName_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "RequestName" member function callback
	template < class Delegate >
	void _RequestName_memStub(::DBus::PendingCall &call) {
		_RequestName_memBind<Delegate>* bind = static_cast<_RequestName_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		uint32_t argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "RequestName" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall RequestName_async(
		const std::string& argin0,
		const uint32_t& argin1,
		Delegate* delegate,
		typename _RequestName_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		wi << argin1;
		call.member("RequestName");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_RequestName_memStub<Delegate>);
      std::auto_ptr<_RequestName_memBind<Delegate> > binding(new _RequestName_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	uint32_t RequestName(const std::string& argin0, const uint32_t& argin1, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		wi << argin1;
		call.member("RequestName");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		uint32_t argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "ReleaseName"
	template < class Delegate >
	struct _ReleaseName_memBind {
		typedef void (Delegate::*Method)(
			const uint32_t &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_ReleaseName_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "ReleaseName" member function callback
	template < class Delegate >
	void _ReleaseName_memStub(::DBus::PendingCall &call) {
		_ReleaseName_memBind<Delegate>* bind = static_cast<_ReleaseName_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		uint32_t argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "ReleaseName" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall ReleaseName_async(
		const std::string& argin0,
		Delegate* delegate,
		typename _ReleaseName_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("ReleaseName");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_ReleaseName_memStub<Delegate>);
      std::auto_ptr<_ReleaseName_memBind<Delegate> > binding(new _ReleaseName_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	uint32_t ReleaseName(const std::string& argin0, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("ReleaseName");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		uint32_t argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "StartServiceByName"
	template < class Delegate >
	struct _StartServiceByName_memBind {
		typedef void (Delegate::*Method)(
			const uint32_t &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_StartServiceByName_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "StartServiceByName" member function callback
	template < class Delegate >
	void _StartServiceByName_memStub(::DBus::PendingCall &call) {
		_StartServiceByName_memBind<Delegate>* bind = static_cast<_StartServiceByName_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		uint32_t argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "StartServiceByName" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall StartServiceByName_async(
		const std::string& argin0,
		const uint32_t& argin1,
		Delegate* delegate,
		typename _StartServiceByName_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		wi << argin1;
		call.member("StartServiceByName");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_StartServiceByName_memStub<Delegate>);
      std::auto_ptr<_StartServiceByName_memBind<Delegate> > binding(new _StartServiceByName_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	uint32_t StartServiceByName(const std::string& argin0, const uint32_t& argin1, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		wi << argin1;
		call.member("StartServiceByName");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		uint32_t argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "Hello"
	template < class Delegate >
	struct _Hello_memBind {
		typedef void (Delegate::*Method)(
			const std::string &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_Hello_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "Hello" member function callback
	template < class Delegate >
	void _Hello_memStub(::DBus::PendingCall &call) {
		_Hello_memBind<Delegate>* bind = static_cast<_Hello_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		std::string argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "Hello" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall Hello_async(
		Delegate* delegate,
		typename _Hello_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		call.member("Hello");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_Hello_memStub<Delegate>);
      std::auto_ptr<_Hello_memBind<Delegate> > binding(new _Hello_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	std::string Hello(int timeout = -1) {
		::DBus::CallMessage call;
		call.member("Hello");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		std::string argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "NameHasOwner"
	template < class Delegate >
	struct _NameHasOwner_memBind {
		typedef void (Delegate::*Method)(
			const bool &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_NameHasOwner_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "NameHasOwner" member function callback
	template < class Delegate >
	void _NameHasOwner_memStub(::DBus::PendingCall &call) {
		_NameHasOwner_memBind<Delegate>* bind = static_cast<_NameHasOwner_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		bool argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "NameHasOwner" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall NameHasOwner_async(
		const std::string& argin0,
		Delegate* delegate,
		typename _NameHasOwner_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("NameHasOwner");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_NameHasOwner_memStub<Delegate>);
      std::auto_ptr<_NameHasOwner_memBind<Delegate> > binding(new _NameHasOwner_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	bool NameHasOwner(const std::string& argin0, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("NameHasOwner");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		bool argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "ListNames"
	template < class Delegate >
	struct _ListNames_memBind {
		typedef void (Delegate::*Method)(
			const std::vector< std::string > &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_ListNames_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "ListNames" member function callback
	template < class Delegate >
	void _ListNames_memStub(::DBus::PendingCall &call) {
		_ListNames_memBind<Delegate>* bind = static_cast<_ListNames_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		std::vector< std::string > argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "ListNames" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall ListNames_async(
		Delegate* delegate,
		typename _ListNames_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		call.member("ListNames");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_ListNames_memStub<Delegate>);
      std::auto_ptr<_ListNames_memBind<Delegate> > binding(new _ListNames_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	std::vector< std::string > ListNames(int timeout = -1) {
		::DBus::CallMessage call;
		call.member("ListNames");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		std::vector< std::string > argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "AddMatch"
	template < class Delegate >
	struct _AddMatch_memBind {
		typedef void (Delegate::*Method)(
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_AddMatch_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "AddMatch" member function callback
	template < class Delegate >
	void _AddMatch_memStub(::DBus::PendingCall &call) {
		_AddMatch_memBind<Delegate>* bind = static_cast<_AddMatch_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();		}
		(bind->delegate->*bind->method)(ret);
		delete bind;
	}

public:

	// "AddMatch" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall AddMatch_async(
		const std::string& argin0,
		Delegate* delegate,
		typename _AddMatch_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("AddMatch");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_AddMatch_memStub<Delegate>);
      std::auto_ptr<_AddMatch_memBind<Delegate> > binding(new _AddMatch_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	void AddMatch(const std::string& argin0, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("AddMatch");
		::DBus::Message ret = invoke_method(call, timeout);
	}

private:

	// Class member function binding for "RemoveMatch"
	template < class Delegate >
	struct _RemoveMatch_memBind {
		typedef void (Delegate::*Method)(
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_RemoveMatch_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "RemoveMatch" member function callback
	template < class Delegate >
	void _RemoveMatch_memStub(::DBus::PendingCall &call) {
		_RemoveMatch_memBind<Delegate>* bind = static_cast<_RemoveMatch_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();		}
		(bind->delegate->*bind->method)(ret);
		delete bind;
	}

public:

	// "RemoveMatch" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall RemoveMatch_async(
		const std::string& argin0,
		Delegate* delegate,
		typename _RemoveMatch_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("RemoveMatch");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_RemoveMatch_memStub<Delegate>);
      std::auto_ptr<_RemoveMatch_memBind<Delegate> > binding(new _RemoveMatch_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	void RemoveMatch(const std::string& argin0, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("RemoveMatch");
		::DBus::Message ret = invoke_method(call, timeout);
	}

private:

	// Class member function binding for "GetNameOwner"
	template < class Delegate >
	struct _GetNameOwner_memBind {
		typedef void (Delegate::*Method)(
			const std::string &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_GetNameOwner_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "GetNameOwner" member function callback
	template < class Delegate >
	void _GetNameOwner_memStub(::DBus::PendingCall &call) {
		_GetNameOwner_memBind<Delegate>* bind = static_cast<_GetNameOwner_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		std::string argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "GetNameOwner" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall GetNameOwner_async(
		const std::string& argin0,
		Delegate* delegate,
		typename _GetNameOwner_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("GetNameOwner");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_GetNameOwner_memStub<Delegate>);
      std::auto_ptr<_GetNameOwner_memBind<Delegate> > binding(new _GetNameOwner_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	std::string GetNameOwner(const std::string& argin0, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("GetNameOwner");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		std::string argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "ListQueuedOwners"
	template < class Delegate >
	struct _ListQueuedOwners_memBind {
		typedef void (Delegate::*Method)(
			const std::vector< std::string > &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_ListQueuedOwners_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "ListQueuedOwners" member function callback
	template < class Delegate >
	void _ListQueuedOwners_memStub(::DBus::PendingCall &call) {
		_ListQueuedOwners_memBind<Delegate>* bind = static_cast<_ListQueuedOwners_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		std::vector< std::string > argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "ListQueuedOwners" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall ListQueuedOwners_async(
		const std::string& argin0,
		Delegate* delegate,
		typename _ListQueuedOwners_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("ListQueuedOwners");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_ListQueuedOwners_memStub<Delegate>);
      std::auto_ptr<_ListQueuedOwners_memBind<Delegate> > binding(new _ListQueuedOwners_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	std::vector< std::string > ListQueuedOwners(const std::string& argin0, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("ListQueuedOwners");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		std::vector< std::string > argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "GetConnectionUnixUser"
	template < class Delegate >
	struct _GetConnectionUnixUser_memBind {
		typedef void (Delegate::*Method)(
			const uint32_t &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_GetConnectionUnixUser_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "GetConnectionUnixUser" member function callback
	template < class Delegate >
	void _GetConnectionUnixUser_memStub(::DBus::PendingCall &call) {
		_GetConnectionUnixUser_memBind<Delegate>* bind = static_cast<_GetConnectionUnixUser_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		uint32_t argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "GetConnectionUnixUser" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall GetConnectionUnixUser_async(
		const std::string& argin0,
		Delegate* delegate,
		typename _GetConnectionUnixUser_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("GetConnectionUnixUser");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_GetConnectionUnixUser_memStub<Delegate>);
      std::auto_ptr<_GetConnectionUnixUser_memBind<Delegate> > binding(new _GetConnectionUnixUser_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	uint32_t GetConnectionUnixUser(const std::string& argin0, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("GetConnectionUnixUser");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		uint32_t argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "GetConnectionUnixProcessID"
	template < class Delegate >
	struct _GetConnectionUnixProcessID_memBind {
		typedef void (Delegate::*Method)(
			const uint32_t &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_GetConnectionUnixProcessID_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "GetConnectionUnixProcessID" member function callback
	template < class Delegate >
	void _GetConnectionUnixProcessID_memStub(::DBus::PendingCall &call) {
		_GetConnectionUnixProcessID_memBind<Delegate>* bind = static_cast<_GetConnectionUnixProcessID_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		uint32_t argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "GetConnectionUnixProcessID" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall GetConnectionUnixProcessID_async(
		const std::string& argin0,
		Delegate* delegate,
		typename _GetConnectionUnixProcessID_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("GetConnectionUnixProcessID");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_GetConnectionUnixProcessID_memStub<Delegate>);
      std::auto_ptr<_GetConnectionUnixProcessID_memBind<Delegate> > binding(new _GetConnectionUnixProcessID_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	uint32_t GetConnectionUnixProcessID(const std::string& argin0, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("GetConnectionUnixProcessID");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		uint32_t argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "GetConnectionSELinuxSecurityContext"
	template < class Delegate >
	struct _GetConnectionSELinuxSecurityContext_memBind {
		typedef void (Delegate::*Method)(
			const std::vector< uint8_t > &, 
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_GetConnectionSELinuxSecurityContext_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "GetConnectionSELinuxSecurityContext" member function callback
	template < class Delegate >
	void _GetConnectionSELinuxSecurityContext_memStub(::DBus::PendingCall &call) {
		_GetConnectionSELinuxSecurityContext_memBind<Delegate>* bind = static_cast<_GetConnectionSELinuxSecurityContext_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		std::vector< uint8_t > argout0;
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();
			ri >> argout0;		}
		(bind->delegate->*bind->method)(argout0, ret);
		delete bind;
	}

public:

	// "GetConnectionSELinuxSecurityContext" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall GetConnectionSELinuxSecurityContext_async(
		const std::string& argin0,
		Delegate* delegate,
		typename _GetConnectionSELinuxSecurityContext_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("GetConnectionSELinuxSecurityContext");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_GetConnectionSELinuxSecurityContext_memStub<Delegate>);
      std::auto_ptr<_GetConnectionSELinuxSecurityContext_memBind<Delegate> > binding(new _GetConnectionSELinuxSecurityContext_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	std::vector< uint8_t > GetConnectionSELinuxSecurityContext(const std::string& argin0, int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		wi << argin0;
		call.member("GetConnectionSELinuxSecurityContext");
		::DBus::Message ret = invoke_method(call, timeout);
		::DBus::MessageIter ri = ret.reader();
		std::vector< uint8_t > argout;
		ri >> argout;
		return argout;
	}

private:

	// Class member function binding for "ReloadConfig"
	template < class Delegate >
	struct _ReloadConfig_memBind {
		typedef void (Delegate::*Method)(
			CallContext&);

		Delegate* delegate;
		Method method;
		void* data;
		_ReloadConfig_memBind(Delegate* del, Method meth, void* ptr)
		: delegate(del), method(meth), data(ptr) {}
	};


	// Stub for "ReloadConfig" member function callback
	template < class Delegate >
	void _ReloadConfig_memStub(::DBus::PendingCall &call) {
		_ReloadConfig_memBind<Delegate>* bind = static_cast<_ReloadConfig_memBind<Delegate>*>(call.data());
		CallContext ret(*this, call, bind->data);
		if (!ret.error()) {
			::DBus::MessageIter ri = ret.msg().reader();		}
		(bind->delegate->*bind->method)(ret);
		delete bind;
	}

public:

	// "ReloadConfig" asynchronous call with member function callback
	template < class Delegate >
	::DBus::PendingCall ReloadConfig_async(
		Delegate* delegate,
		typename _ReloadConfig_memBind<Delegate>::Method method,
		void* data,
		int timeout = -1) {
		::DBus::CallMessage call;
		::DBus::MessageIter wi = call.writer();
		call.member("ReloadConfig");
		::DBus::PendingCallSlot slot;
		slot = new ::DBus::CallbackNoReturn<DBus_proxy, ::DBus::PendingCall &>(
			this, &DBus_proxy::_ReloadConfig_memStub<Delegate>);
      std::auto_ptr<_ReloadConfig_memBind<Delegate> > binding(new _ReloadConfig_memBind<Delegate>(delegate, method, data));
		::DBus::PendingCall async = invoke_method_async(call, slot, binding.get(), timeout);
      binding.release();
		return async;
	}

	void ReloadConfig(int timeout = -1) {
		::DBus::CallMessage call;
		call.member("ReloadConfig");
		::DBus::Message ret = invoke_method(call, timeout);
	}

private:
	// DBus signal: reimplement this method to receive the "NameOwnerChanged" signal
	virtual void NameOwnerChanged(const std::string &, const std::string &, const std::string &) {}

private:
	// DBus signal: reimplement this method to receive the "NameLost" signal
	virtual void NameLost(const std::string &) {}

private:
	// DBus signal: reimplement this method to receive the "NameAcquired" signal
	virtual void NameAcquired(const std::string &) {}

private:
	void _NameOwnerChanged_stub(const ::DBus::SignalMessage &sig) {
		::DBus::MessageIter ri = sig.reader();
		std::string arg0; ri >> arg0;
		std::string arg1; ri >> arg1;
		std::string arg2; ri >> arg2;
		NameOwnerChanged(arg0, arg1, arg2);
	}

private:
	void _NameLost_stub(const ::DBus::SignalMessage &sig) {
		::DBus::MessageIter ri = sig.reader();
		std::string arg0; ri >> arg0;
		NameLost(arg0);
	}

private:
	void _NameAcquired_stub(const ::DBus::SignalMessage &sig) {
		::DBus::MessageIter ri = sig.reader();
		std::string arg0; ri >> arg0;
		NameAcquired(arg0);
	}
};

} } 
#endif//DBUSXXX____INCLUDE_DBUS_C___DBUS_PROXY_PROXY_MARSHAL_H
